--[[
--                                           MOUNTY 2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Function Library (to smooth transition when the Blizzard API changes)
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_TestPrinter()
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_BUILD = |r"..MOUNTY_BUILD);
end

function Mounty_Mount(mountid)
	if (MOUNTY_BUILD < 60) then
		CallCompanion("MOUNT", mountid);
	else
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_BUILD = |r"..MOUNTY_BUILD);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> C_MountJournal.Summon("..mountid..") |r");
		C_MountJournal.Summon(mountid);
	end
end

function Mounty_Dismount()
	if (MOUNTY_BUILD < 60) then
		DismissCompanion("MOUNT");
	else
		C_MountJournal.Dismiss();
	end
end

function Mounty_GetNumMounts()
	local returnvalue
	if (MOUNTY_BUILD < 60) then
		returnvalue = GetNumCompanions("MOUNT");
	else
		returnvalue = C_MountJournal.GetNumMounts();
	end
	return returnvalue;
end

function Mounty_GetMountInfo(i)
	local ID, ctn, spellID, icon, issummoned;
	if (MOUNTY_BUILD < 60) then
		ID, ctn, spellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
	else
		ID = 0;
		ctn, spellID, icon, issummoned = C_MountJournal.GetMountInfo(i);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_BUILD = |r"..MOUNTY_BUILD);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> i = |r"..i);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> ID = |r"..ID);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> ctn = |r"..ctn);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> spellID = |r"..spellID);

	end
	return ID, ctn, spellID, icon, issummoned;
end

function Mounty_603Continent(zone)
	if(MOUNTY_WOWBUILD == "6.0.3") then
		if (zone == 485) then
			zone = "Draenor";
		end
		if (zone == "Outland") then
			zone = "Pandaria";
		end
		if (zone == 466) then
			zone = "The Maelstrom";
		end
		if (zone == "Eastern") then
			zone = "Northrend";
		end
		if (zone == 14) then
			zone = "Outland";
		end
		if (zone == "Kalimdor") then
			zone = "Eastern Kingdoms";
		end
		if (zone == 13) then
			zone = "Kalimdor";
		end
	end

	return zone;
end



